# Basic Config
esphome:
  name: ${NAME}
  platform: ESP32
  board: esp32cam

# WiFi connection
wifi:
  ssid: !secret WIFI_SSID
  password: !secret WIFI_PASS
  manual_ip:
    static_ip: ${CAM_IP}
    subnet: ${CAM_SUBNET}
    gateway: ${CAM_GW}
    dns1: ${CAM_DNS1}

  # Enable fallback hotspot (captive portal) in case wifi connection fails
  ap:
    ssid: !secret FALLBACK_HOTSPOT_SSID
    password: !secret FALLBACK_HOTSPOT_PASS

captive_portal:

logger:
  baud_rate: 57600
  #level: INFO

# Enable Home Assistant API
api:
  encryption:
    key: !secret ENCRYPTION_KEY

ota:
  password: !secret OTA_PASS

# Camera component
esp32_camera:
  external_clock:
    pin: GPIO0
    frequency: 20MHz
  i2c_pins:
    sda: GPIO26
    scl: GPIO27
  # DO NOT change data_pins order!
  data_pins: [GPIO5, GPIO18, GPIO19, GPIO21, GPIO36, GPIO39, GPIO34, GPIO35]
  vsync_pin: GPIO25
  href_pin: GPIO23
  pixel_clock_pin: GPIO22
  power_down_pin: GPIO32

# Image settings
  name: ${NAME}
  #resolution: 640x480 #VGA
  resolution: 800x600 #SVGA
  #resolution: 1024x768 #XGA
  max_framerate: 24 fps
  idle_framerate: 0.2 fps
  vertical_flip: false
  horizontal_mirror: false
  special_effect: none
  test_pattern: false
  jpeg_quality: 10 # from 10 (best) to 63 (worst)
  contrast: 0
  brightness: 0
  saturation: 0
  wb_mode: home

button:
  - platform: restart
    name: ${NAME} restart

# switch:      
#   - platform: restart
#     name: ${NAME} restart
    
sensor:
  - platform: wifi_signal
    name: ${NAME} WiFi Signal
    update_interval: 60s
  - platform: uptime
    name: ${NAME} Uptime

text_sensor:
  - platform: version
    name: ${NAME} Version
  - platform: wifi_info
    ssid:
      name: ${NAME} WiFi info
    ip_address:
      name: ${NAME} IP address
    
binary_sensor:
  - platform: status
    name: ${NAME} status
  - platform: gpio
    pin: 
     number: GPIO13
     mode: INPUT_PULLUP
    name: ${NAME} Motion
    device_class: motion
    
output:
  - platform: gpio
    pin:
      number: GPIO4
    id: gpio_4_flashlight
  - platform: gpio
    pin:
      number: GPIO33
      inverted: True
    id: gpio_33_statuslight

light:
  - platform: binary
    output: gpio_4_flashlight
    name: ${NAME} Flash Light
    id: flash
  - platform: binary   
    output: gpio_33_statuslight
    name: ${NAME} Status Light

# Camera web-server
esp32_camera_web_server:
  - port: 8080
    mode: stream
  - port: 8081
    mode: snapshot